﻿using System.Linq;
public class MoreLoot : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.less-grind";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    private static int multiplier = 10;
    public static float ExtraSettingsAPI_GetSliderValue(string SettingName) => 0;
    public void ExtraSettingsAPI_Load()
    {
        multiplier = (int)System.Math.Round(ExtraSettingsAPI_GetSliderValue("multiplier"));
    }
    public void ExtraSettingsAPI_SettingsClose()
    {
        multiplier = (int)System.Math.Round(ExtraSettingsAPI_GetSliderValue("multiplier"));
    }
    [HarmonyLib.HarmonyPatch(typeof(PlayerInventory), "AddItem", new System.Type[] { typeof(string), typeof(int) })]
    public class HarmonyPatch_PlayerInventory_AddItem
    {
        private static System.Collections.Generic.IDictionary<string, bool> multiplyItemNames = new System.Collections.Generic.Dictionary<string, bool>()
        {
            { "Arrow_Metal", false },
            { "Arrow_Stone", false },
            { "Arrow_Titanium", false },
            { "Axe", false },
            { "Axe_Stone", false },
            { "Axe_Titanium", false },
            { "Backpack", false },
            { "Backpack_Advanced", false },
            { "Banana", true },
            { "Battery", false },
            { "Battery_Advanced", true },
            { "Berries_Red", true },
            { "Binoculars", false },
            { "BioFuel", true },
            { "Blueprint_Antenna", false },
            { "Blueprint_AnchorStationaryAdvanced", false },
            { "Blueprint_BackpackAdvanced", false },
            { "Blueprint_BatteryAdvanced", false },
            { "Blueprint_BatteryCharger", false },
            { "Blueprint_BiofuelExtractor", false },
            { "Blueprint_BiofuelExtractorAdvanced", false },
            { "Blueprint_Canteen", false },
            { "Blueprint_Cropplot_Large_Tier3", false },
            { "Blueprint_Cropplot_Medium_Tier3", false },
            { "Blueprint_Cropplot_Small_Tier3", false },
            { "Blueprint_DetailPlank", false },
            { "Blueprint_ElectricGrill", false },
            { "Blueprint_ElectricPurifier", false },
            { "Blueprint_EngineControls", false },
            { "Blueprint_Firework", false },
            { "Blueprint_Fueltank", false },
            { "Blueprint_HeadLight", false },
            { "Blueprint_HeadLight_Advanced", false },
            { "Blueprint_Machete", false },
            { "Blueprint_MetalDetector", false },
            { "Blueprint_MotorWheel", false },
            { "Blueprint_Pipe_Fuel", false },
            { "Blueprint_Pipe_Water", false },
            { "Blueprint_Reciever", false },
            { "Blueprint_Recycler", false },
            { "Blueprint_SmelterElectric", false },
            { "Blueprint_SteeringWheel", false },
            { "Blueprint_Storage_Large", false },
            { "Blueprint_TitaniumTools", false },
            { "Blueprint_WaterTank", false },
            { "Blueprint_WindTurbine", false },
            { "Blueprint_ZiplineBase", false },
            { "Blueprint_ZiplineTool", false },
            { "Blueprint_ZiplineToolElectric", false },
            { "Bolt", true },
            { "Bow", false },
            { "Brick_Dry", true },
            { "Bucket", false },
            { "Bucket_Milk", false },
            { "Canteen_Empty", false },
            { "Canteen_SaltWater", false },
            { "Canteen_Water", false },
            //{ "Cassette_Classical", false },
            { "Cassette_EDM", false },
            //{ "Cassette_Pop", false },
            { "Cassette_Rock", false },
            { "Cassette_Elevator", false },
            { "Cassette_TradingPost", false },
            { "CaveMushroom", true },
            { "Chili", true },
            { "CircuitBoard", true },
            { "Claybowl_CoconutChicken", true },
            { "Claybowl_Empty", true },
            { "Claybowl_HeadBroth", true },
            { "Claybowl_HeartyStew", true },
            { "Claybowl_Leftover", true },
            { "Claybowl_RootVegetableSoup", true },
            { "Claybowl_SimpleFishStew", true },
            { "ClayPlate_BBQ", true },
            { "ClayPlate_CatfishDeluxe", true },
            { "ClayPlate_MushroomOmelette", true },
            { "ClayPlate_SalmonSalad", true },
            { "ClayPlate_SharkDinner", true },
            { "ClayPlate_SteakWithJam", true },
            { "ClayPlate_Sushi", true },
            { "Clay", true },
            { "Coconut", true },
            { "Color_Black", true },
            { "Color_Blue", true },
            { "Color_Red", true },
            { "Color_White", true },
            { "Color_Yellow", true },
            { "Compass", false },
            { "Cooked_Beet", true },
            { "Cooked_Catfish", true },
            { "Cooked_Drumstick", true },
            { "Cooked_GenericMeat", true },
            { "Cooked_Herring", true },
            { "Cooked_Mackerel", true },
            { "Cooked_Pomfret", true },
            { "Cooked_Potato", true },
            { "Cooked_Salmon", true },
            { "Cooked_Shark", true },
            { "Cooked_Tilapia", true },
            { "CopperIngot", true },
            { "CopperOre", true },
            { "Dirt", true },
            { "DrinkingGlass_CoconutBeat", true },
            { "DrinkingGlass_Leftover", true },
            { "DrinkingGlass_Mangonana", true },
            { "DrinkingGlass_RedbeetShot", true },
            { "DrinkingGlass_RedMelon", true },
            { "DrinkingGlass_SilverSmoothie", true },
            { "DrinkingGlass_SimpleSmoothie", true },
            { "DrinkingGlass_SpicyPineberry", true },
            { "DrinkingGlass_StrawberryColada", true },
            { "DrinkingGlass", true },
            { "Egg", true },
            { "Equipment_LeatherChest", false },
            { "Equipment_LeatherHelmet", false },
            { "Equipment_LeatherLegs", false },
            { "ExplosiveGoo", true },
            { "ExplosivePowder", true },
            { "Feather", true },
            { "FishingBait_Advanced", true },
            { "FishingBait_Expert", true },
            { "FishingBait_Simple", true },
            { "FishingRod", false },
            { "FishingRod_Metal", false },
            { "Flipper", false },
            { "Flower_Black", true },
            { "Flower_Blue", true },
            { "Flower_Red", true },
            { "Flower_White", true },
            { "Flower_Yellow", true },
            { "Glass", true },
            { "Hammer", false },
            //{ "Hat_Captain", false },
            { "Hat_Chef", false },
            { "Hat_Construction", false },
            { "Hat_Diving", false },
            { "Hat_Fishing", false },
            { "Hat_Glasses_Aviator", false },
            { "Hat_Glasses_Disguise", false },
            { "Hat_Mayor", false },
            //{ "Hat_Pilot", false },
            { "Hat_Pirate", false },
            { "Hat_Sailor", false },
            //{ "Hat_Tiki", false },
            { "Head_AnglerFish", false },
            { "Head_Bear", false },
            { "Head_Boar", false },
            { "Head_Hyena", false },
            { "Head_HyenaBoss", false },
            { "HeadLight", false },
            { "HeadLight_Advanced", false },
            { "Head_MamaBear", false },
            { "Head_PoisonPuffer", false },
            { "Head_PolarBear", false },
            { "Head_Screecher_Caravan", false },
            { "Head_Screecher", false },
            { "Head_Shark", false },
            { "HealingSalve_Good", true },
            { "HealingSalve", true },
            { "Hinge", true },
            { "HoneyComb", true },
            { "Hook_Plastic", false },
            { "Hook_Scrap", false },
            { "Hook_Titanium", false },
            { "Jar_Bee", true },
            { "Jar_Honey", true },
            { "Juniper", true },
            { "Leather", true },
            { "Machete", false },
            { "Mango", true },
            { "MetalDetector", false },
            { "MetalIngot", true },
            { "MetalOre", true },
            { "Mystery_Package", true },
            { "Nail", true },
            { "NetCanister", true },
            { "NetGun", false },
            { "OxygenBottle", false },
            { "Paddle", false },
            { "PaintBrush", false },
            { "Pineapple", true },
            { "Placeable_Anchor_Stationary", false },
            { "Placeable_Anchor_Stationary_Advanced", false },
            { "Placeable_Anchor_Throwable", true },
            { "Placeable_Bathtub", false },
            { "Placeable_BatteryCharger", false },
            { "Placeable_Bed_Basic", false },
            { "Placeable_Bed_Hammock", false },
            { "Placeable_Bed_Wood", false },
            { "Placeable_BeeHive", false },
            { "Placeable_BiofuelExtractor", false },
            { "Placeable_BiofuelExtractor_Advanced", false },
            { "Placeable_BirdsNest", false },
            { "Placeable_Bookpile", false },
            { "Placeable_Bookpile_Standing", false },
            { "Placeable_Brick_Wet", false },
            { "Placeable_Calendar", false },
            { "Placeable_Candelabra", false },
            { "Placeable_Candlestick", false },
            { "Placeable_Chair_Basic", false },
            { "Placeable_Chair_Stool", false },
            { "Placeable_Chair_Stool_Small", false },
            { "Placeable_Chair_Wood", false },
            { "Placeable_Clock_Basic", false },
            { "Placeable_Clock_Fine", false },
            { "Placeable_CollectionNet_Advanced", false },
            { "Placeable_CollectionNet_Basic", false },
            { "Placeable_CookingPot", false },
            { "Placeable_CookingStand_Food_One", false },
            { "Placeable_CookingStand_Food_Two", false },
            { "Placeable_CookingStand_Food_Electric", false },
            { "Placeable_CookingStand_Purifier_One", false },
            { "Placeable_CookingStand_Purifier_Two", false },
            { "Placeable_CookingStand_Smelter", false },
            { "Placeable_CookingStand_Smelter_Electric", false },
            { "Placeable_Cropplot_Grass", true },
            { "Placeable_Cropplot_Large", false },
            { "Placeable_Cropplot_Large_Tier3", false },
            { "Placeable_Cropplot_Medium", false },
            { "Placeable_Cropplot_Medium_Tier3", false },
            { "Placeable_Cropplot_Shoe", true },
            { "Placeable_Cropplot_Small", false },
            { "Placeable_Cropplot_Small_Tier3", false },
            { "Placeable_Cupboard_Large", false },
            { "Placeable_Cupboard_Medium", false },
            { "Placeable_Cupboard_Small", false },
            { "Placeable_Curtain_Horizontal", false },
            { "Placeable_Curtain_Vertical", false },
            { "Placeable_Cutlery", false },
            { "Placeable_DetailPlank", true },
            { "Placeable_DrawBridgeLong", false },
            { "Placeable_DrawBridgeShort", false },
            { "Placeable_Electric_Purifier", false },
            { "Placeable_EngineControls", false },
            { "Placeable_FirewoodRack", false },
            { "Placeable_Firework", true },
            { "Placeable_Flag_01", false },
            { "Placeable_Flag_02", false },
            { "Placeable_Flag_03", false },
            { "Placeable_Flag_04", false },
            { "Placeable_Flag_05", false },
            { "Placeable_Flag_06", false },
            { "Placeable_Flag_07", false },
            { "Placeable_Flower_AloeVera", false },
            { "Placeable_Flower_Cactus", false },
            { "Placeable_Flower_Hibiscus", false },
            { "Placeable_Flower_Monstera", false },
            { "Placeable_Flower_Rose", false },
            { "Placeable_Flower_Sunflower", false },
            { "Placeable_FoundationCounter", false },
            { "Placeable_Fridge", false },
            { "Placeable_FuelTank", false },
            { "Placeable_GiantClam", false },
            { "Placeable_GlassCandle", false },
            { "Placeable_HonkHorn_1", false },
            { "Placeable_HonkHorn_2", false },
            { "Placeable_HonkHorn_3", false },
            { "Placeable_Juicer", false },
            { "Placeable_Lantern_Basic", false },
            { "Placeable_Lantern_FireBasket", false },
            { "Placeable_Lantern_Fireplace", false },
            { "Placeable_Lantern_Metal", false },
            { "Placeable_LuckyCat", false },
            { "Placeable_MajorTom", false },
            { "Placeable_MotivationalSign_1", false },
            { "Placeable_MotivationalSign_2", false },
            { "Placeable_MotivationalSign_3", false },
            { "Placeable_MotivationalSign_4", false },
            { "Placeable_MotorWheel", false },
            { "Placeable_Mug", false },
            //{ "Placeable_Nametag", false },
            { "Placeable_OpenBook", false },
            { "Placeable_Outhouse", false },
            { "Placeable_Painting_André", false },
            { "Placeable_Painting_Crafted_1", false },
            { "Placeable_Painting_Crafted_2", false },
            { "Placeable_Painting_Crafted_3", false },
            { "Placeable_Painting_Crafted_4", false },
            { "Placeable_Painting_Ellen", false },
            { "Placeable_Painting_Felicia", false },
            { "Placeable_Painting_Gabriel", false },
            { "Placeable_Painting_Illayda", false },
            { "Placeable_Painting_Petter", false },
            { "Placeable_Painting_Semih", false },
            { "Placeable_Painting_Tangaroa_1", false },
            { "Placeable_Painting_Tangaroa_2", false },
            { "Placeable_Painting_Tangaroa_3", false },
            { "Placeable_Painting_Tangaroa_4", false },
            { "Placeable_Painting_Tangaroa_5", false },
            { "Placeable_Painting_William", false },
            { "Placeable_PaintMill", false },
            { "Placeable_PaperBundle", false },
            { "Placeable_Piano", false },
            { "Placeable_Pipe_Fuel", true },
            { "Placeable_Pipe_Water", true },
            { "Placeable_Quill", false },
            { "Placeable_Radio", false },
            { "Placeable_Reciever", false },
            { "Placeable_Reciever_Antenna", false },
            { "Placeable_Recipe_BBQ", false },
            { "Placeable_Recipe_CatfishDeluxe", false },
            { "Placeable_Recipe_CoconutBeat", false },
            { "Placeable_Recipe_CoconutChicken", false },
            { "Placeable_Recipe_HeadBroth", false },
            { "Placeable_Recipe_HeartyStew", false },
            { "Placeable_Recipe_Mangonana", false },
            { "Placeable_Recipe_MushroomOmelette", false },
            { "Placeable_Recipe_RedbeetShot", false },
            { "Placeable_Recipe_RedMelon", false },
            { "Placeable_Recipe_SalmonSalad", false },
            { "Placeable_Recipe_SharkDinner", false },
            { "Placeable_Recipe_SilverSmoothie", false },
            { "Placeable_Recipe_SimpleFishStew", false },
            { "Placeable_Recipe_SimpleSmoothie", false },
            { "Placeable_Recipe_SpicyPineberry", false },
            { "Placeable_Recipe_SteakWithJam", false },
            { "Placeable_Recipe_StrawberryColada", false },
            { "Placeable_Recipe_Sushi", false },
            { "Placeable_Recipe_VegetableSoup", false },
            { "Placeable_Recycler", false },
            { "Placeable_ResearchTable", false },
            { "Placeable_RhinoSharkTrophy", false },
            { "Placeable_Rug_Door", false },
            { "Placeable_Rug_Rectangle", false },
            { "Placeable_Rug_Round_Large", false },
            { "Placeable_Rug_Round_Small", false },
            { "Placeable_Sail", false },
            { "Placeable_Scarecrow_Advanced", true },
            { "Placeable_Scarecrow", true },
            { "Placeable_ScrapMechanic", false },
            { "Placeable_Shelf_Large", false },
            { "Placeable_Shelf_Small_Basic", false },
            { "Placeable_Shelf_Small_Fine", false },
            { "Placeable_Shelf_Wood", false },
            { "Placeable_Sign", false },
            { "Placeable_Sofa2Seat", false },
            { "Placeable_Sofa3Seat", false },
            { "Placeable_Sofa", false },
            { "Placeable_Sprinkler", false },
            { "Placeable_SteeringWheel", false },
            { "Placeable_Storage_Large", false },
            { "Placeable_Storage_Medium", false },
            { "Placeable_Storage_Small", false },
            { "Placeable_Streamer", false },
            { "Placeable_StringLight_Horizontal", false },
            { "Placeable_StringLight_Vertical", false },
            { "Placeable_Surfboard", false },
            { "Placeable_Table_Basic", false },
            { "Placeable_Table_Round", false },
            { "Placeable_Table_Round_Small", false },
            { "Placeable_Table_Sofa_Round", false },
            { "Placeable_Table_Sofa_Square", false },
            { "Placeable_Table_Square", false },
            { "Placeable_Table_Square_Small", false },
            { "Placeable_Table_Square_Tall", false },
            { "Placeable_TangaroaPlant_1", false },
            { "Placeable_TangaroaPlant_2", false },
            { "Placeable_TangaroaPlant_3", false },
            { "Placeable_TangaroaPlant_4", false },
            { "Placeable_TangaroaPlant_5", false },
            { "Placeable_TangaroaPlant_6", false },
            { "Placeable_Temperance_Cutlery", false },
            { "Placeable_Temperance_Mug", false },
            { "Placeable_Temperance_Rug_1", false },
            { "Placeable_Temperance_Rug_2", false },
            { "Placeable_Temperance_Painting_1", false },
            { "Placeable_Temperance_Painting_2", false },
            { "Placeable_Temperance_Painting_3", false },
            { "Placeable_Temperance_Plant_1", false },
            { "Placeable_Temperance_Plant_2", false },
            { "Placeable_Temperance_Plant_3", false },
            { "Placeable_TicTacToe", false },
            //{ "Placeable_TikiPole_Complete", false },
            //{ "Placeable_TikiPole_Feet", false },
            //{ "Placeable_TikiPole_Mid_1", false },
            { "Placeable_TikiPole_Mid_2", false },
            { "Placeable_TikiPole_Top", false },
            { "Placeable_ToyRobot", false },
            { "Placeable_ToyRobot_Golden", false },
            { "Placeable_Trashcan", false },
            { "Placeable_TrophyBoard_Large", false },
            { "Placeable_TrophyBoard_Medium", false },
            { "Placeable_TrophyBoard_Small", false },
            { "Placeable_Utopia_Bottle", false },
            { "Placeable_Utopia_DanglyDecoration_1", false },
            { "Placeable_Utopia_DanglyDecoration_2", false },
            { "Placeable_Utopia_DanglyDecoration_3", false },
            { "Placeable_Utopia_DanglyDecoration_4", false },
            { "Placeable_Utopia_DanglyDecoration_5", false },
            { "Placeable_Utopia_DanglyDecoration_6", false },
            { "Placeable_Utopia_Herb_1", false },
            { "Placeable_Utopia_Herb_2", false },
            { "Placeable_Utopia_Herb_3", false },
            { "Placeable_Utopia_Herb_4", false },
            { "Placeable_Utopia_Herb_5", false },
            { "Placeable_Utopia_Herb_6", false },
            { "Placeable_Utopia_LightBottleWhite", false },
            { "Placeable_Utopia_LightBottleYellow", false },
            { "Placeable_Utopia_Plant_1", false },
            { "Placeable_Utopia_Plant_2", false },
            { "Placeable_Utopia_Plant_3", false },
            { "Placeable_Wardrobe", false },
            { "Placeable_WaterTank", false },
            { "Placeable_WindTurbine", false },
            { "Placeable_WorldGlobe", false },
            { "Placeable_ZiplineBase", false },
            { "Plank", true },
            { "PlasticBottle_Empty", false },
            { "PlasticBottle_SaltWater", false },
            { "PlasticBottle_Water", false },
            { "PlasticCup_Empty", false },
            { "PlasticCup_SaltWater", false },
            { "PlasticCup_Water", false },
            { "Plastic", true },
            { "Raw_Beet", true },
            { "Raw_Catfish", true },
            { "Raw_Drumstick", true },
            { "Raw_GenericMeat", true },
            { "Raw_Herring", true },
            { "Raw_Mackerel", true },
            { "Raw_Pomfret", true },
            { "Raw_Potato", true },
            { "Raw_Salmon", true },
            { "Raw_Shark", true },
            { "Raw_Tilapia", true },
            { "Rope", true },
            { "Sand", true },
            { "Scrap", true },
            { "SeaVine", true },
            { "Seed_Banana", true },
            { "Seed_Birch", true },
            { "Seed_Flower_Black", false },
            { "Seed_Flower_Blue", false },
            { "Seed_Flower_Red", false },
            { "Seed_Flower_White", false },
            { "Seed_Flower_Yellow", false },
            { "Seed_Mango", true },
            { "Seed_Palm", true },
            { "Seed_Pine", true },
            { "Seed_Pineapple", true },
            { "Seed_Strawberry", true },
            { "Seed_Watermelon", true },
            { "SharkBait", true },
            { "Shear", false },
            { "Shovel", false },
            { "SilverAlgae", true },
            { "Spear_Plank", false },
            { "Spear_Scrap", false },
            { "Stone", true },
            { "Strawberry", true },
            { "SweepNet", false },
            { "Sword_Titanium", false },
            { "Thatch", true },
            { "TitaniumIngot", true },
            { "TitaniumOre", true },
            { "TradeToken", true },
            { "Trashcube", true },
            { "TrophyFish_T1_Glow_Shrimp", true },
            { "TrophyFish_T1_NetNibbler", true },
            { "TrophyFish_T1_SharpCarp", true },
            { "TrophyFish_T2_Foamspitter", true },
            { "TrophyFish_T2_Pufferlisk", true },
            { "TrophyFish_T2_TrapSnapper", true },
            { "TrophyFish_T3_Lionfish", true },
            { "TrophyFish_T3_Lunarfish", true },
            { "TrophyFish_T3_Pentapus", true },
            { "TrophyFish_T3_PinkPike", true },
            { "TrophyFish_T3_RainbowLobster", true },
            { "TrophyFish_T3_Sharkeater", true },
            { "Turmeric", true },
            { "VineGoo", true },
            { "Watermelon", true },
            { "Wool", true },
            { "ZiplineTool", false },
            { "ZiplineTool_Electric", false },
        };
        static void Prefix(ref string uniqueItemName, ref int amount)
        {
            bool toMultiply = false;
            if (!multiplyItemNames.TryGetValue(uniqueItemName, out toMultiply))
            {
                UnityEngine.Debug.Log("DEBUG MoreLoot uniqueItemName: " + uniqueItemName);
            }
            else if (toMultiply)
            {
                amount *= multiplier;
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(RemovePlaceables), "ReturnItemsFromBlock", new System.Type[] { typeof(Block), typeof(Network_Player), typeof(bool) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    [HarmonyLib.HarmonyBefore(new string[] { "com.aidanamite.FullRecycling" })]
    public class HarmonyPatch_RemovePlaceables_ReturnItemsFromBlock
    {
        private class PatchInstruction
        {
            public System.Reflection.Emit.OpCode opCode;
            public string operandString;
            public System.Reflection.Emit.OpCode? newOpCode = null;
            public object newOperand = null;
        }
        private static PatchInstruction[] patchInstructions = new PatchInstruction[]{
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "Item_Base buildableItem" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "ItemInstance_Recipe settings_recipe" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "CostMultiple[] get_NewCost()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Br_S, operandString = "System.Reflection.Emit.Label" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldelem_Ref },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "System.Int32 amount" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Conv_R4 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_R4, newOperand = (System.Single) 0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Mul },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Call, operandString = "Int32 CeilToInt(Single)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (31)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_2 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Brfalse_S, operandString = "System.Reflection.Emit.Label" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldarg_1 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "PlayerInventory get_Inventory()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple (30)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldfld, operandString = "Item_Base[] items" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldelem_Ref },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "System.String get_UniqueName()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (31)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "Int32 AddItem(System.String, Int32)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Pop },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_1 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Add },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Stloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "System.Int32 (29)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldloc_S, operandString = "CostMultiple[] (28)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldlen },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Conv_I4 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Blt_S, operandString = "System.Reflection.Emit.Label" },
        };
        static System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> Transpiler(System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> codeInstructionsEnumerable)
        {
            System.Collections.Generic.List<HarmonyLib.CodeInstruction> codeInstructions = new System.Collections.Generic.List<HarmonyLib.CodeInstruction>(codeInstructionsEnumerable);
            int? startPatch = null;
            int codeLength = codeInstructions.Count;
            int patchLength = patchInstructions.Length;
            for (int codeStart = 0; codeStart < codeLength; codeStart++)
            {
                if (codeStart + patchLength > codeLength)
                {
                    break;
                }
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = codeStart + patchCursor;
                    HarmonyLib.CodeInstruction codeInstruction = codeInstructions[codeCursor];
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (codeInstruction.opcode == patchInstruction.opCode && (patchInstruction.operandString == null || codeInstruction.operand.ToString() == patchInstruction.operandString))
                    {
                        if (patchCursor == 0)
                        {
                            startPatch = codeStart;
                        }
                        if (patchCursor == patchLength - 1)
                        {
                            break;
                        }
                    }
                    else
                    {
                        startPatch = null;
                        break;
                    }
                }
                if (startPatch != null)
                {
                    break;
                }
            }
            if (startPatch != null)
            {
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = (int)startPatch + patchCursor;
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (patchInstruction.newOpCode != null)
                    {
                        codeInstructions[codeCursor].opcode = (System.Reflection.Emit.OpCode)patchInstruction.newOpCode;
                    }
                    if (patchInstruction.newOperand != null)
                    {
                        codeInstructions[codeCursor].operand = patchInstruction.newOperand;
                    }
                }
            }
            return codeInstructions.AsEnumerable();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(QuestItemManager), "AddQuestItemsNetworked", new System.Type[] { typeof(bool), typeof(QuestItem[]) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_QuestItemManager_AddQuestItemsNetworked
    {
        static void Prefix(ref bool sendNotification, ref QuestItem[] questItems)
        {
            foreach (QuestItem questItem in questItems)
            {
                if (questItem.SOQuestItem.name == "Tangaroa_Token") {
                    questItem.itemCount *= multiplier;
                }
            }
        }
    }
}
